<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_installation".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnInstallation".
 *
 * Columns in table "cpn_installation" available as properties of the model,
 * followed by relations of table "cpn_installation" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property integer $account_id
 * @property integer $practice_id
 * @property string $installation_code
 * @property integer $allow_installation_flag
 * @property string $name
 * @property string $comments
 * @property string $installation_identifier
 * @property string $secret
 * @property string $passphrase
 * @property string $machine_name
 * @property string $operating_system
 * @property integer $enabled_flag
 * @property integer $del_flag
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property CpnCommunicationQueue[] $cpnCommunicationQueues
 * @property CpnEhrCommunicationQueue[] $cpnEhrCommunicationQueues
 * @property CpnEhrInstallation[] $cpnEhrInstallations
 * @property Account $account
 * @property Account $addedByAccount
 * @property Practice $practice
 * @property CpnInstallationPractice[] $cpnInstallationPractices
 * @property CpnInstallationProvider[] $cpnInstallationProviders
 * @property CpnSoftwareInstallation[] $cpnSoftwareInstallations
 * @property CpnSoftwareVersionLog[] $cpnSoftwareVersionLogs
 */
abstract class BaseCpnInstallation extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_installation';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnInstallation|CpnInstallations', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        return array(
            array('account_id, practice_id, name, secret, added_by_account_id', 'required'),
            array('account_id, practice_id, allow_installation_flag, enabled_flag, del_flag, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, installation_identifier', 'length', 'max' => 255),
            array('installation_code', 'length', 'max' => 6),
            array('name, secret, passphrase, machine_name, operating_system', 'length', 'max' => 100),
            array('comments, date_added, date_updated', 'safe'),
            array('installation_code, allow_installation_flag, comments, installation_identifier, passphrase, machine_name, operating_system, enabled_flag, del_flag, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, account_id, practice_id, installation_code, allow_installation_flag, name, comments, installation_identifier, secret, passphrase, machine_name, operating_system, enabled_flag, del_flag, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnCommunicationQueues' => array(self::HAS_MANY, 'CpnCommunicationQueue', 'cpn_installation_id'),
            'cpnEhrCommunicationQueues' => array(self::HAS_MANY, 'CpnEhrCommunicationQueue', 'cpn_installation_id'),
            'cpnEhrInstallations' => array(self::HAS_MANY, 'CpnEhrInstallation', 'cpn_installation_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'cpnInstallationPractices' => array(self::HAS_MANY, 'CpnInstallationPractice', 'cpn_installation_id'),
            'cpnInstallationProviders' => array(self::HAS_MANY, 'CpnInstallationProvider', 'cpn_installation_id'),
            'cpnSoftwareInstallations' => array(self::HAS_MANY, 'CpnSoftwareInstallation', 'cpn_installation_id'),
            'cpnSoftwareVersionLogs' => array(self::HAS_MANY, 'CpnSoftwareVersionLog', 'cpn_installation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'account_id' => null,
            'practice_id' => null,
            'installation_code' => Yii::t('app', 'Installation Code'),
            'allow_installation_flag' => Yii::t('app', 'Allow Installation Flag'),
            'name' => Yii::t('app', 'Name'),
            'comments' => Yii::t('app', 'Comments'),
            'installation_identifier' => Yii::t('app', 'Installation Identifier'),
            'secret' => Yii::t('app', 'Secret'),
            'passphrase' => Yii::t('app', 'Passphrase'),
            'machine_name' => Yii::t('app', 'Machine Name'),
            'operating_system' => Yii::t('app', 'Operating System'),
            'enabled_flag' => Yii::t('app', 'Enabled Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'cpnCommunicationQueues' => null,
            'cpnEhrCommunicationQueues' => null,
            'cpnEhrInstallations' => null,
            'account' => null,
            'addedByAccount' => null,
            'practice' => null,
            'cpnInstallationPractices' => null,
            'cpnInstallationProviders' => null,
            'cpnSoftwareInstallations' => null,
            'cpnSoftwareVersionLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('installation_code', $this->installation_code, true);
        $criteria->compare('allow_installation_flag', $this->allow_installation_flag);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('comments', $this->comments, true);
        $criteria->compare('installation_identifier', $this->installation_identifier, true);
        $criteria->compare('secret', $this->secret, true);
        $criteria->compare('passphrase', $this->passphrase, true);
        $criteria->compare('machine_name', $this->machine_name, true);
        $criteria->compare('operating_system', $this->operating_system, true);
        $criteria->compare('enabled_flag', $this->enabled_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
